/*############################################################################
#
#	Golfinho - Corrector gramatical para o OpenOffice.org
#
#	Version: 1.0
#
#	Arquivo: ConexionCorrector.java
#
#	Remarks: Abre un socket e establece a comunicaci�n entre a aplicaci�n
#           e o corrector.
#
#       Creada o 15 de enero de 2007, 16:00
#
############################################################################*/
package com.imaxin.exeria.utilities;

import com.imaxin.exeria.Iface;
import java.io.*;
import java.net.*;

/**
 *
 * @author adrian
 */
public class EngineConnector {

    private static final String CODIFICATION_UTF = "UTF-8";
    private static final String CODIFICATION_ANSI = "ANSI";
    private static final String CODIFICATION_ISO = "ISO-8859-1";
    
    private static final String CHECK = "CHECK|";
    private static final String SPELL = "SPELL|";
    private static final String RESPONSE_OK = "CHECK|OK";
    
    private static final String LOCAL_SERVER_IP = "localhost";
    private static final String ANGEL_SERVER_IP_WIN = "192.168.1.43";
    private static final String ANGEL_SERVER_IP_LIN = "192.168.1.44";
    
    private static final int PORT_NUMBER = 3551;
    
    private static Socket smtpSocket = null;
    private static DataOutputStream out = null;
    private static BufferedReader in = null;
    private static String strResponse = null;    
    
    private static final int MAX_TIMES_SOCKET = 2;
    private static final int MAX_TIMES_STREAM = 20;
    private static int countTimes = 0;

    public static String checkText(String text) {        
        String responseCheck = checkSpellText(text, CHECK);
        if (responseCheck.equals(RESPONSE_OK)) {            
            return "";
        } else {
            String responseSpell = checkSpellText(text, SPELL);
            return responseSpell;
        }

    }

    public static String checkSpellText(String text, String action) {
        
        countTimes = 0;
        openSocket();

        try {

            out.write((action + text).getBytes(CODIFICATION_ISO));
            int counter = 0;
            while (!Iface.flagEndThread) {                
                
                counter++;
                
                if (in.ready()) {
                    // Read 
                    strResponse = "";
                    String temp = null;
                    while ((temp = in.readLine()) != null) {
                        strResponse += temp;
                    }
                    break;
                } else {                    
                    XeCore.emptyStreams();
                    Thread.sleep(100);
                    if(counter == MAX_TIMES_STREAM){
                        return null;
                    }
                }
            }
        } catch (Exception e) {
            return null;
        }

        closeSocket();

        return strResponse;
    }

    private static void closeSocket() {
        try {
            smtpSocket.close();
        } catch (Exception ex) {
            System.out.println("ex socket = " + ex);
        }    
        try {
            out.close();
        } catch (Exception ex) {
            System.out.println("ex outstream = " + ex);
        }      
        try {
            in.close();
        } catch (Exception ex) {
            System.out.println("ex instream = " + ex);
        }                
    }

    private static void openSocket() {

        try {
            smtpSocket = new Socket(LOCAL_SERVER_IP, PORT_NUMBER);

            out = new DataOutputStream(smtpSocket.getOutputStream());

            in = new BufferedReader(new InputStreamReader(smtpSocket.getInputStream(), CODIFICATION_ISO));                        
                        
        } catch (Exception e) {    
            countTimes++;
            System.out.println("e socket connect = " + e);
            if( countTimes == MAX_TIMES_SOCKET){
                countTimes = 0;
                return;
            }else{
                try {
                    Thread.sleep(100);
                } catch (InterruptedException ex) {                    
                }
                openSocket();
            }
        }
    }
}
