/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.imaxin.exeria.utilities;

import java.io.StringReader;
import javax.swing.JOptionPane;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

/**
 *
 * @author stefanos
 */
public class NSError {

    private String response;
    private String originalSentence;
    private String newSentence;
    private String stringError;
    private String[] suggestions;
    private int selectionStart;
    private int selectionEnd;
    private boolean canCorrect;

    public boolean canCorrect() {
        return canCorrect;
    }

    public NSError() {
    }

    public int getSelectionEnd() {
        return selectionEnd;
    }

    public int getSelectionStart() {
        return selectionStart;
    }

    public NSError(String originalSentence, String response) {
        this.originalSentence = originalSentence;
        constructError(response);
        validateError();
    }

    public void setOriginalSentence(String originalSentence) {
        this.originalSentence = originalSentence;
    }    

    private void constructError(String response) {
        
        this.response = response;
        
        try {
            DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
            DocumentBuilder docBuilder = documentBuilderFactory.newDocumentBuilder();
            Document domDoc = docBuilder.parse(new InputSource(new StringReader(response.replace("SPELL|", ""))));

            NodeList nodeListError = domDoc.getElementsByTagName("ERROR");
            NodeList nodeListSuggest = domDoc.getElementsByTagName("SUGGEST");
            NodeList nodeListReplace = domDoc.getElementsByTagName("REPLACE");

            suggestions = new String[nodeListSuggest.getLength()];

            for (int i = 0; i < nodeListError.getLength(); i++) {
                Node node = nodeListError.item(i);
                this.stringError = node.getTextContent();
            }

            for (int i = 0; i < nodeListSuggest.getLength(); i++) {
                Node node = nodeListSuggest.item(i);
                this.suggestions[i] = (node.getTextContent());
            }

            for (int i = 0; i < nodeListReplace.getLength(); i++) {
                Node node = nodeListReplace.item(i);
                this.stringError = node.getTextContent();
            }

        } catch (Exception e) {            
            
        }
    }

    public String getOriginalSentence() {
        return originalSentence;
    }

    public String getNewSentence(String replace) {
        newSentence = originalSentence.replaceFirst(stringError, replace);
        return newSentence;
    }

    public String getStringError() {
        return stringError;
    }

    public String[] getSuggestions() {
        return suggestions;
    }

    private void validateError() {
        try{
        if (!stringError.equals("") && !suggestions.equals("") && originalSentence.contains(stringError)) {
            canCorrect = true;
            selectionStart = originalSentence.indexOf(stringError);
            selectionEnd = selectionStart + stringError.length();
        } else {
            System.out.println("-----------------------");
            System.out.println("SENTENCIA = " + this.originalSentence);
            System.out.println("RESPUESTA = " + this.response);            
            System.out.println("-----------------------");
            canCorrect = false;            
        }
    }catch(Exception e){
        canCorrect = false;
    }
    }
}

