package com.imaxin.exeria.utilities;

import com.sun.star.frame.XController;
import com.sun.star.frame.XModel;
import com.sun.star.text.XParagraphCursor;
import com.sun.star.text.XSentenceCursor;
import com.sun.star.text.XText;
import com.sun.star.text.XTextCursor;
import com.sun.star.text.XTextDocument;
import com.sun.star.text.XTextViewCursor;
import com.sun.star.text.XTextViewCursorSupplier;
import com.sun.star.uno.UnoRuntime;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author stefanos
 */
public class TextProcessor {

    XModel xModel;
    XController xController;
    XTextViewCursorSupplier xViewCursorSupplier;
    XTextViewCursor xTextViewCursor;
    XText xDocumentText;
    XTextCursor xModelCursor;
    XSentenceCursor xSentenceCursor;
    XParagraphCursor xParagraphCursor;
    boolean moreParagraphsOO = true;
    boolean moreSentencesOO = true;
    boolean moreSentences = false;
    String textSentence = "";
    String[] sentences = null;
    int sentenceIndex = 0;
    int numSentences = 0;
    private static final String SENTENCE_SEPARATOR_REGEX = "\\.|\\,|\\:|\\;|\\?|\\!|\\|\\";

    public TextProcessor(XTextDocument xTextDoc) {

        xModel = (XModel) UnoRuntime.queryInterface(XModel.class, xTextDoc);
        xController = xModel.getCurrentController();
        xViewCursorSupplier = (XTextViewCursorSupplier) UnoRuntime.queryInterface(XTextViewCursorSupplier.class, xController);
        xTextViewCursor = xViewCursorSupplier.getViewCursor();


        xDocumentText = xTextViewCursor.getText();
        xModelCursor = xDocumentText.createTextCursorByRange(xTextViewCursor.getStart());

        xSentenceCursor = (XSentenceCursor) UnoRuntime.queryInterface(
                XSentenceCursor.class, xModelCursor);

        xParagraphCursor = (XParagraphCursor) UnoRuntime.queryInterface(
                XParagraphCursor.class, xModelCursor);

        xParagraphCursor.gotoStartOfParagraph(false);

    }

    public String getNextSentenceOO() {

        while (moreParagraphsOO) {
            while (moreSentencesOO) {

                xSentenceCursor.gotoEndOfSentence(true);
                textSentence = xSentenceCursor.getString();
                xTextViewCursor.gotoRange(xSentenceCursor.getStart(), false);
                xTextViewCursor.gotoRange(xSentenceCursor.getEnd(), true);
                if (!textSentence.equals("")) {
                    return textSentence;
                }
                moreSentencesOO = xSentenceCursor.gotoNextSentence(false);

            }
            moreParagraphsOO = xParagraphCursor.gotoNextParagraph(false);
            moreSentencesOO = xSentenceCursor.gotoStartOfSentence(false);
        }

        return null;
    }

    public String getNextSentence() {

        if (moreSentences) {
            if (sentenceIndex < numSentences) {
                return sentences[sentenceIndex++];
            } else {
                moreSentences = false;
                goToNextSentence();
                return getNextSentence();
            }
        } else {
            String ooSentence = getNextSentenceOO();
            if (ooSentence != null) {
                sentences = ooSentence.split(SENTENCE_SEPARATOR_REGEX);
                numSentences = sentences.length;
                if (numSentences > 0) {
                    moreSentences = true;
                    sentenceIndex = 1;
                    return sentences[0];
                } else {
                    goToNextSentence();
                    return getNextSentence();
                }
            } else {
                return null;
            }
        }

    }

    public void goToCurrentSentence() {
        xSentenceCursor.gotoRange(xTextViewCursor.getStart(), false);
        xSentenceCursor.gotoStartOfSentence(false);
    }

    public void rewriteSentence(String originalSentence, String sentence) {
        textSentence = textSentence.replace(originalSentence, sentence);
        xSentenceCursor.setString(textSentence);
        xTextViewCursor.gotoRange(xSentenceCursor.getStart(), false);
        xTextViewCursor.gotoRange(xSentenceCursor.getEnd(), true);
        sentences[sentenceIndex] = textSentence;
    }

    public void goToNextSentence() {
        xSentenceCursor.gotoNextSentence(false);
    }

    public void goToStart() {
        xSentenceCursor.gotoStart(false);
        moreParagraphsOO = true;
        moreSentencesOO = true;
    }

    public void reSelectSentence() {            
        sentenceIndex--;
    }
    
}
