/*
 *
 * Copyright (C) 2006-2007  imaxin|software
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * */

#include <iostream>
#include <string>

#include "HashError.h"
#ifndef STRINGUTIL_H
#define STRINGUTIL_H
#include "StringUtil.h"
#endif
using namespace std;

HashError::HashError(const string path_error)
{
	int res;

	_db_err = new Db(NULL, DB_CXX_NO_EXCEPTIONS);	

	if ((res = _db_err->open(NULL, path_error.c_str(), NULL,DB_HASH, DB_RDONLY, 0))) {
		exit(res);
	}	
}

HashError::~HashError()
{
	_db_err->close(0);	
	delete _db_err;
}

int HashError::searchInHash(const string analysis, string *suggestion) {
	Dbt key, data;	
	int error;
	int found = 0;
	
	key.set_data((void *) analysis.c_str());
	key.set_size(analysis.length());
	
	if ( (error = _db_err->get(NULL, &key, &data, 0)) == 0) {
		found = 1;
		if (suggestion) {			
			*suggestion = (char *) data.get_data();
			*suggestion = suggestion->substr(0, data.get_size());
		}		
	}

	return found;
}

int HashError::searchPattern(const string analysis, vector<string> *v_suggestion) {
	string suggestion = "";
	int error = 0;

	if ( (error = searchInHash(analysis, &suggestion)) )
		if (v_suggestion)
			StringUtil::SplitString(suggestion, TUPLA, *v_suggestion);

	return error;
}
