/*
 *
 * Copyright (C) 2006-2007  imaxin|software
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * */

#include <iostream>
#include <string>
#include <db_cxx.h>
#include <pcrecpp.h>

#include "HashFalse.h"

using namespace std;

HashFalse::HashFalse(const string path)
{
	int ret;

	_dbp = new Db(NULL, DB_CXX_NO_EXCEPTIONS);

	if ( (ret = _dbp->open(NULL, path.c_str(), NULL, DB_HASH, DB_RDONLY, 0)) != 0 ) {

		cerr << "ERRN_ERRORHASH_OPEN" << " " << path.c_str() << endl;
		exit(EXIT_FAILURE);
	}

}

HashFalse::~HashFalse()
{
	_dbp->close(0);
}

int HashFalse::foundPattern(const string pattern)
{
	return 0;
}

void HashFalse::showAll(void)
{
	Dbt key, data;
	int ret;
	unsigned int len;
	TPattern buffer;
	
	memset(&buffer, 0, sizeof(TPattern));
	
	_dbp->cursor(NULL, &_cursor, 0);

	while ( (ret = _cursor->get(&key, &data, DB_NEXT)) == 0) {				
		copyToT_PATTERN(&data, &buffer);
		
		switch (buffer.len) {
			case 1:
				cout << buffer.eE1 << SEPARADOR << buffer.lE1 << endl;
				break;
			case 2:
				cout << buffer.eE1 << SEPARADOR << buffer.lE1 << UNION
					<< buffer.eE2 << SEPARADOR << buffer.lE2 << endl;
				break;
			case 3:
				cout << buffer.eE1 << SEPARADOR << buffer.lE1 << UNION
					<< buffer.eE2 << SEPARADOR << buffer.lE2 << UNION
					<< buffer.eE3 << SEPARADOR << buffer.lE3 << endl;
				break;
			case 4:
				cout << buffer.eE1 << SEPARADOR << buffer.lE1 << UNION
					<< buffer.eE2 << SEPARADOR << buffer.lE2 << UNION
					<< buffer.eE3 << SEPARADOR << buffer.lE3 << UNION
					<< buffer.eE4 << SEPARADOR << buffer.lE4 << endl;
				break;
			case 5:
				cout << buffer.eE1 << SEPARADOR << buffer.lE1 << UNION
					<< buffer.eE2 << SEPARADOR << buffer.lE2 << UNION
					<< buffer.eE3 << SEPARADOR << buffer.lE3 << UNION
					<< buffer.eE4 << SEPARADOR << buffer.lE4 << UNION
					<< buffer.eE5 << SEPARADOR << buffer.lE5 << endl;
				break;
		}
		
	}

	_cursor->close();	
}

void HashFalse::copyToT_PATTERN(Dbt *data, T_PATTERN *buffer)
{	
	buffer->len = ((T_PATTERN *) (data->get_data()))->len;
	memcpy(buffer->eE1, ((T_PATTERN *) (data->get_data()))->eE1, sizeof(buffer->eE1));
	memcpy(buffer->lE1, ((T_PATTERN *) (data->get_data()))->lE1, sizeof(buffer->lE1));
	memcpy(buffer->eE2, ((T_PATTERN *) (data->get_data()))->eE2, sizeof(buffer->eE2));
	memcpy(buffer->lE2, ((T_PATTERN *) (data->get_data()))->lE2, sizeof(buffer->lE2));
	memcpy(buffer->eE3, ((T_PATTERN *) (data->get_data()))->eE3, sizeof(buffer->eE3));
	memcpy(buffer->lE3, ((T_PATTERN *) (data->get_data()))->lE3, sizeof(buffer->lE3));
	memcpy(buffer->eE4, ((T_PATTERN *) (data->get_data()))->eE4, sizeof(buffer->eE4));
	memcpy(buffer->lE4, ((T_PATTERN *) (data->get_data()))->lE4, sizeof(buffer->lE4));
	memcpy(buffer->eE5, ((T_PATTERN *) (data->get_data()))->eE5, sizeof(buffer->eE5));
	memcpy(buffer->lE5, ((T_PATTERN *) (data->get_data()))->lE5, sizeof(buffer->lE5));
	
}
