/*
 *
 * Copyright (C) 2006-2007  imaxin|software
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * */

#include <iostream>
#include <string>

#include "NGram.h"
#include "ErrorConst.h"

using namespace std;

NGram::NGram(const string text)
{	
	if (this->lenEqualToOne(text))
		_results.push_back(text);		
	else
		StringUtil::SplitString(text, "+", _results, false);
}

NGram::NGram(const vector<string> vs)
{
	_results = vs;
}

NGram::NGram(const list<sentence> ls)
{
	list<sentence>::const_iterator s;
	word::const_iterator a;
	sentence::const_iterator w;

	for (s = ls.begin(); s != ls.end(); s++)
		for (w = s->begin(); w != s->end(); w++)
			_vword.push_back(*w);

}

NGram::~NGram()
{
}

vector<string> NGram::splitString(int num)
{
	int i = 0, j = 0;

	vector<string> list;
	string buffer;

	/* Comprobamos que el tamao del ngrama no supere el
	 * tamao del texto etiquetado
	 * */
	if (num < _results.size() + 1)
		while (i < _results.size()) {

			buffer = "";

			for (j = 0; j < num; j++)
				if ( (num + i) <= _results.size() )
					if ( ((j + 1) < num) )
						buffer += _results.at(j + i) + "+";
					else
						buffer += _results.at(j + i);

			if ( (num + i) <= _results.size() )
				list.push_back(buffer);

			i++;
		}

	return list;
}

vector< vector<word> > NGram::splitWord(int num)
{
	int count, i, j;
	vector<word> vbuffer;
	vector< vector<word> > vv;
	count = i = j = 0;

	/* Comprobamos que el tamao del ngrama no supere el
	 * tamao del texto etiquetado
	 * */
	if (num < _vword.size() + 1)
		while (i < _vword.size()) {
			vbuffer.clear();
			for (j = 0; j < num; j++)
				if ( (num + i) <=_vword.size() )
					vbuffer.push_back(_vword.at(j + i));

			if ( (num + i) <= _vword.size() )
				vv.push_back(vbuffer);

			i++;
		}

	return vv;
}

int NGram::lenEqualToOne(const string text) {
	int pos = string::npos;

	if ( (pos = text.find("+")) == string::npos ) {
		if ( (pos = text.find("_")) != string::npos )
			return 1;
		else
			return 0;
	}
	else
		return 0;
}