#include <string>
#include <pcrecpp.h>

#include "freeling.h"
#include "freeling/traces.h"
#ifndef UTIL_H
#define UTIL_H
#include "Util.h"
#endif
#ifndef PHRASE_H
#define PHRASE_H
#include "Phrase.h"
#endif
#include "PhraseStructure.h"

using namespace std;

PhraseStructure::PhraseStructure(string text): Phrase(text) {
	_ora = text;
}

PhraseStructure::PhraseStructure(PhraseStructure &p): Phrase(p) {
	
}

PhraseStructure::~PhraseStructure() {
	
}

PhraseStructure & PhraseStructure::operator = (const PhraseStructure &p) {
	*this = p;

	return *this;
}

int PhraseStructure::isDeterminerThePreviousTag(int index) {
	if (index > 0) {
		string tag = getParole(index - 1);
		return pcrecpp::RE("^D.*$").FullMatch(tag) ? 1 : 0;
	}
	else
		return 0;	
}

int PhraseStructure::isDeterminerMaleThePreviousTag(int index) {
	if (index > 0) {
		string tag = getParole(index - 1);
		return (pcrecpp::RE("^D.*M.*$").FullMatch(tag) || pcrecpp::RE("^DA0000$").FullMatch(tag)) ? 1 : 0;
	}
	else
		return 0;	
}

int PhraseStructure::isContractionThePrePreviousTag(int index) {
	if (index - 2 > -1) {
		string tag = getParole(index - 2);
		return pcrecpp::RE("^SPS00$").FullMatch(tag) ? 1 : 0;
	}
	else
		return 0;	
}

int PhraseStructure::isContractionWithArticleAndName(int index) {
	if (index > -1) {		
		string tag_current	= getParole(index);
		string tag_next		= getParole(index + 1);

		return (pcrecpp::RE("^SPS00$").FullMatch(tag_current) && 
				pcrecpp::RE("^D.*$").FullMatch(tag_next)) ? 1 : 0;
	}
	else
		return -1;
}

