/*
 *
 * Copyright (C) 2006-2007  imaxin|software
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * */

#include <iostream>
#include <string>
#include <pcrecpp.h>

#include "Util.h"

using namespace std;

int Util::setPosErrorAndType(int value, int *pos_error, int *type) {
	if (0x1000 & value) {
		*type = 1;
		*pos_error = value - 0x1000;
	}
	else if (0x2000 & value) {
		*type = 2;
		*pos_error = value - 0x2000;
	}
	else if (0x4000 & value) {
		*type = 3;
		*pos_error = value - 0x4000;
	}
	else
		return 0;

	if (*type < 1 || *type > 3)
		return 0;
	if (*pos_error < 0)
		return 0;

	return 1;
}

int Util::TrimVector(vector<string> *ptr) {
	vector<string> buffer;
	int i, size = ptr->size();

	for (i = 0; i < size; i++) {
		string item = ptr->at(i);
		StringUtil::Trim(item);
		buffer.push_back(item);
	}

	*ptr = buffer;

	return ptr->size();
}

int Util::textInPhraseIsUpperCase(int pos) {
	return 0;
}

string Util::substitute(const string &source, const string &olds, const string &news) {
  string s = source;

  unsigned int p=s.find(olds , 0);
#ifdef CYGWIN
  while (p!=static_cast<unsigned int>(string::npos))
#else
  while (p!=static_cast<unsigned int>(wstring::npos))
#endif
  {
    s.replace(p, olds.length(), news);
    p+=news.length();
    p=s.find(olds,p);
  }

  return s;
}

int Util::isUpper(const string text) {
	int i = 0;
	int size = text.size();
	int fall = 1;
	int ffirst = 0;

	for (i = 0; i < size; i++) {
		if (StringUtil::isUpper(text[i])) {
			if (i == 0)
				ffirst = 1;
		}
		else
			fall = 0;
	}

	if (fall)
		return UPPER_ALL;

	if (ffirst)
		return UPPER_FIRST;

	return UPPER_NOTHING;
}

int Util::findStringInVector(const string text, const vector<string> list, int trim) {
	int size = list.size();
	int i = 0;
	int found = 0;

	while (i < size && !found) {
		if (trim) {
			string buffer_text(text);
			string buffer_list(list.at(i));
			StringUtil::Trim(buffer_text);
			StringUtil::Trim(buffer_list);

			if (buffer_text == buffer_list)
				found = 1;
		}
		else if (text == list.at(i))
			found = 1;

		i++;
	}

	return found? i : -1;
}

string Util::convertCase(const string source, int type) {
	string buffer = source;

	if (type == UPPER_NOTHING)
		return StringUtil::ToLower(buffer);
	else if (type == UPPER_ALL)
		return StringUtil::ToUpper(buffer);
	else if (type == UPPER_FIRST) {

		if (buffer.length() > 1) {
			string first = buffer.substr(0, 1);
			string rest = buffer.substr(1, buffer.length() - 1);

			return StringUtil::ToUpper(first) + rest;
		}
		else
			return StringUtil::ToUpper(&buffer[0]);
	}
	else {
		return StringUtil::ToLower(buffer);
	}
}

vector<string> Util::convertCase(const vector<string> source, int type) {
	int size = source.size();
	int i = 0;
	vector<string> templist;

	for (i = 0; i < size; i++) {
		string buffer = source.at(i);
		buffer = Util::convertCase(buffer, type);
		templist.push_back(buffer);
	}

	return templist;
}
