/*
 *
 * Copyright (C) 2006-2007  imaxin|software
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * */

#include <iostream>
#include <string>

#include "freeling.h"
#include "freeling/traces.h"

#include "NGram.h"
#include "HashException.h"
#include "HashError.h"
#include "Disambiguator.h"
#ifndef SUGGESTION_H
#define SUGGESTION_H
#include "Suggestion.h"
#endif
#include "Solution.h"
#include "GrammarService.h"
#include "Package.h"
#ifndef PHRASE_STRUCTURE_H
#define PHRASE_STRUCTURE_H
#include "PhraseStructure.h"
#endif PHRASE_STRUCTURE_H

#define LANGUAGE "gl"
#define NGRAM_MAX 10
#define NGRAM_MIN 3
#define MINIMAL_SIZE 1

using namespace std;

class Engine
{
	private:
		HashException *_hException;
		HashError *_hError;
		HashError *_hError_invariable;
		HashError *_hError_invariableFirst;
		Disambiguator *_disambiguator;

		int searchException(PhraseStructure *p);
		int searchError(PhraseStructure *p, string *lemma_pattern_error, vector<string> *v_sugg);
		int findCollectionInHash(vector<string> v_analysis_ngram, vector<string> *v_suggestion);
		int validateInput(string input);
		int buildXmlSolution(const string error, int pos_error, vector<string> v_sugg, string *sol);
		vector<string> taggerFirstWord(vector<string> v_suggs);
	public:
		Engine();
		~Engine();
		int check(const string text);
		int spell(const string text, string *sol);

};

