/*
 *
 * Copyright (C) 2006-2007  imaxin|software
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * */

#include <iostream>
#include <string>
#include <pcrecpp.h>

#include "freeling.h"
#include "freeling/traces.h"
#ifndef UTIL_H
#define UTIL_H
#include "Util.h"
#endif

using namespace std;

class Phrase {	
public:
	// Public constructor and destructor
	Phrase();
	Phrase(Phrase &p);
	Phrase(const string ora);
	~Phrase();
	Phrase &operator = (const Phrase &p);

	// Public routines		
	void setNotDisambiguated(const string ora);
	void setDisambiguated(list<sentence> ls);	
	int getSize();
	string getSpan(int index);
	string getSpan(int init, int end);
	string getWord(int index);
	string getLemma(int index);
	string getParole(int index);
	string getOriginalString();
	string getParolesConcat();
	string getAnalysisConcat();
	vector<string> getLemmaCollection();
	vector<string> getLemmaCollectionFilteredByName();
	
protected:
	int _status;
	string _ora;
	vector<word> _list;
};

