/*
 *
 * Copyright (C) 2006-2007  imaxin|software
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * */

#include <iostream>
#include <string>
#include <db_cxx.h>

#include "StringUtil.h"
#include "Type.h"
#include "HashFile.h"

using namespace std;

void showKeys(Dbt key);
void showSuggs(Dbt data);

int main(int argc, char **argv)
{
	Db *mydbase = new Db(NULL, DB_CXX_NO_EXCEPTIONS);
	Dbc *cursor;
	Dbt key, data;
	int error;
	int ret;

	try {
		mydbase->open(NULL, argv[1], NULL,DB_HASH, DB_RDONLY, 0);

		mydbase->cursor(NULL, &cursor, 0);

		if (cursor) {

			while ( (ret = cursor->get(&key, &data, DB_NEXT))  == 0) {
				showKeys(key);
				// showSuggs(data);
			}
			cursor->close();
		}
		else
			return error;
	}
	catch (DbException &e) {
		mydbase->err(e.get_errno(), "Error!");
	}
	return 0;
}

void showKeys(Dbt key)
{
	T_KEY_HASH k;

	memset(k.key, 0, sizeof(k.key));
	memcpy(k.key, key.get_data(), key.get_size());
	printf("%s\n", k.key);
}

void showSuggs(Dbt data)
{
	string s( (char *)data.get_data(), data.get_size());
	cout << s << endl;
}