/*
 *
 * Copyright (C) 2006-2007  imaxin|software
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * */

#include <iostream>
#include <string>
#include <unistd.h>

#include "Engine.h"

#define ENABLE_NLS 1

char *msg[] = {
	"Uso: xecore opcins\n\
	-s		Modo socket\n\
	-i		Modo entrada estndar",
	NULL
};

int main(int argc, char **argv)
{
	int iflag = 0;
	int sflag = 0;
	opterr = 0;

	if (argc == 1) {
		cout << msg[0] << endl;
		exit(EXIT_SUCCESS);
	}

	int co;
	char ch;

	while ((co = getopt(argc, argv, "is") != -1) && !iflag && !sflag) {
		ch = argv[co][1];
		switch(ch) {
		case 'i':
			iflag = 1;
			break;
		case 's':
			sflag = 1;
			break;
		default:
			cout << msg[0] << endl;
			break;
		}
	}

	GrammarService server;
	Engine checker;
	string buffer, xmlSolution;

	if (iflag) {
		while (getline(cin, buffer)) {
			if (checker.check(buffer)) {
				checker.spell(buffer, &xmlSolution);
				cout << xmlSolution << endl;
			}
		}
	}
	else if (sflag){
		while(1) {
			buffer = server.ReadSentence();
			Package pack(buffer);

			if (pack.IsCheck()) {
				if(!checker.check(pack.GetPhrase()))
					server.SendSentence(pack.SetResponse("OK\n"));
				else
					server.SendSentence(pack.SetResponse("ERROR\n"));
			}

			if (pack.IsSpell()) {
				checker.spell(pack.GetPhrase(), &xmlSolution);
				server.SendSentence(pack.SetResponse(xmlSolution));
			}

			if (pack.IsExit())
				exit(EXIT_SUCCESS);
		}
	}

	return 0;
}
